/*------------------------------------------------------
FILE NAME   : cpld.h
DESCRIPTION : cpld header for SG1694.
VERSION     : 0.0.0 (C)aureole
AUTHOR      : Aureole
CREATE DATE : 12.30.2009
MODIFY DATE : 
LOGS        :-\

--------------------------------------------------------*/

#ifndef __cpld_h__
#define __cpld_h__


//-----------------Include files-------------------------//

#include "..\include\hardware.h"
 

//----------------- DEFINE ------------------------------//

//----------------- Hardware ----------------------------//
//CPLD_WR	PB10
#define initialize_cpld_wr()	GPIOB->CRH.B.MODE10=0X3;\
							GPIOB->CRH.B.CNF10=0;

#define	CPLD_WR_ON	GPIOB->BSRR.B.SETIO10=1
#define	CPLD_WR_OFF	GPIOB->BSRR.B.CLRIO10=1

//--------------------------------------------------------//

#define	WR0		0X0000
#define	WR1		0X1000
#define	WR2		0x2000
#define	WR3		0x3000
#define	WR4		0X4000
#define	WR5		0X5000
#define	WR6		0x6000
#define	WR7		0x7000
#define	WR8		0X8000
#define	WR9		0X9000
#define	WR10	0xa000
#define	WR11	0xb000
#define	WR12	0Xc000
#define	WR13	0Xd000
#define	WR14	0xe000
#define	WR15	0xf000



typedef const struct{
	int (* initialize)(void);
	int (* write)(unsigned short int space,unsigned short int data);
}CPLD_T;


typedef union {
	unsigned  short int value;
	struct{
		unsigned short int cha_wave:3;
		unsigned short int chb_wave:3;
		unsigned short int bit6:1;
		unsigned short int bit7:1;
		unsigned short int bit8:1;
		unsigned short int bit9:1;
		unsigned short int bit10:1;
		unsigned short int bit11:1;

	}bits;
}CTL_T;
	
//-----------------Extern functions----------------------//
extern CPLD_T cpld;

extern CTL_T ctl;

#endif //__cpld_h__

